c-----------------------------------------------------------------------
      subroutine IniPar
c-----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incico'
      character*80 fn
      logical table

      ii=index(fnhi(1:nfnhi),".histo")-1
      fn=fnhi(1:ii)//".icp"
      inquire(file=fn,exist=table)

      if(icotabr.eq.1)then  !read from file
      
        if(.not.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fn(1:ii+4),' not found !!!'
          stop
        endif
        write(ifmt,'(3a)')'read from ',fn(1:ii+4),' ...'
        open(97,file=fn,status='old')
        read(97,*) engyx
        read(97,*) laprojx,maprojx,latargx,matargx
        read(97,*) bmaximx
        read(97,*) icospecx,icoremnx,icostrgx
        read(97,*) nxicox,nyicox,nzicox
        read(97,*)xminicox,xmaxicox,yminicox,ymaxicox,zminicox,zmaxicox 
        if(engyx.ne.engy)    stop'variables dont match (1)    '
        if(1000*laprojx+100*maprojx+10*latargx+matargx
     * .ne.1000*laproj+100*maproj+10*latarg+matarg)
     *                       stop'variables dont match (2)    '
        if(bmaximx.ne.bmaxim)stop'variables dont match (3)    '
        if(100*icospecx+10*icoremnx+icostrgx
     * .ne.100*icospec +10*icoremn +icostrg)
     *                       stop'variables dont match (4)    '
        if(100*nxicox+10*nyicox+nzicox.ne.100*nxico+10*nyico+nzico)
     *                       stop'variables dont match (5)    '
        if(100000*xminicox+10000*xmaxicox+1000*yminicox
     *      +100*ymaxicox+10*zminicox+zmaxicox  .ne.
     *     100000*xminico +10000*xmaxico+ 1000*yminico
     *      +100*ymaxico +10*zminico +zmaxico)
     *                       stop'variables dont match (6)    '

        read(97,*) IcoT,IcoC,IcoE,IcoV,IcoF
        close(97)

      elseif(icotabr.eq.0)then  ! calculate

        if(icotabm.eq.1.and.table)then
          write(ifmt,'(//10x,3a//)')'STOP: file '
     *             ,fn(1:ii+4),' already exists !!!'
          stop
        endif
 
        write(ifmt,'(2a)')'calculate iniPar table.',
     *                        ' this may take a while ...'
        if(nrevt.eq.1)call IcoPar(1) 
        call IcoPar(2) 
        if(nrevt.eq.nevent)call IcoPar(3)          
        write(ifmt,'(a)')'calculation of iniPar table finished.'

        if(icotabm.eq.1)then  ! make table
          write(ifmt,'(2a)')'write iniPar table into ',fn(1:ii+4)
          open(97,file=fn,status='new')
          write(97,*) engy
          write(97,*) laproj,maproj,latarg,matarg
          write(97,*) bmaxim
          write(97,*) icospec,icoremn,icostrg
          write(97,*) nxico,nyico,nzico
          write(97,*) xminico,xmaxico,yminico,ymaxico,zminico,zmaxico 
          write(97,*) IcoT,IcoC,IcoE,IcoV,IcoF
          close(97)
        endif

      else

	stop'IniCon: wrong choice'

      endif

      end


c-----------------------------------------------------------------------
      subroutine IcoPar(iflag)
c-----------------------------------------------------------------------
c     energy momentum tensor and flavor current 
c     and corresponding contractions from string method
c
c     iflag = 1 initialization   
c           = 2 sum up density
c           = 3 normalization     
c     
c     output: common blocks /Ico1/ - /Ico5/ 
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incico'
      double precision tpro,zpro,ttar,ztar,ttaus,detap,detat
      common/cttaus/tpro,zpro,ttar,ztar,ttaus,detap,detat 
      dimension un(4,nxico,nyico,nzico)
      common /Ico10/ntot,ish0,irs
      dimension xo(4),uu(4),ps(4)
      
c.....controll output......
      ish0=2                    ! set to zero if you don't want the output
c...........................

      GOTO (1,10,100),iflag
      return
      
 1    do ix=1,nxico
        do iy=1,nyico
          do iz=1,nzico
            do i1=1,4
              do i2=1,3
                IcoC(i2,i1,ix,iy,iz)=0.
              enddo
              do i2=1,4
                IcoT(i1,i2,ix,iy,iz)=0.
              enddo
            enddo
          enddo
        enddo
      enddo
      ntot=0
      return

c......................................

 10   ntot=ntot+1
      taum=1.0                  ! calculate intersection at tau=1 fm/c
                                ! here s and t are just the sigma,tau
                                ! of the kinky-string model. 
                                ! call them s,t to avoid confusion 
                                ! with the ivariant tau


      ttaus=taum
      zz=0.
      istrs=icostrg   
      iremn=icoremn   
      ispec=icospec        

      do i=1,nptl             
        if(ispec.ge.1.and.istptl(i).eq.0.and.i.le.maproj+matarg)then
          call idflav(idptl(i),ifl1,ifl2,ifl3,idummy,idummy)
          xorptl(3,i)=0.0
          xorptl(4,i)=0.0
          call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
          irs=i
          do iii=1,4
            ps(iii)=pptl(iii,i)
          enddo
          call IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
        endif
        if(iremn.ge.1.and.istptl(i).le.11)then
          if(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41)then
            if(idptl(i).gt.10**8)then
              call idqufl(i,idptl(i),nqu,nqd,nqs)
              call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
              irs=i
              do iii=1,4
                ps(iii)=pptl(iii,i)
              enddo
              call IcoAdddro(ps,xo,taum,nqu,nqd,nqs)
            else
              call idflav(idptl(i),ifl1,ifl2,ifl3,idummy,idummy)
              call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
              irs=i
              do iii=1,4
                ps(iii)=pptl(iii,i)
              enddo
              call IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
            endif
          endif
        endif
        if(istrs.ge.1)then
	  if((mod(istptl(i),10).eq.0.and.abs(idptl(i)).le.10).or.
     $  (mod(istptl(i),10).eq.0.and.mod(idptl(i),100).eq.0))then
            call idflav(idptl(i),ifl1,ifl2,ifl3,idummy,idummy)
            call jtain(i,xo(1),xo(2),xo(3),xo(4),nn,1)
            irs=i
            do iii=1,4
              ps(iii)=pptl(iii,i)
            enddo
            call IcoAddptl(ps,xo,taum,ifl1,ifl2,ifl3)
          endif
        endif		
      enddo

      return
c..............................................
c
c     normalization and contraction of IcoT-tensor
c
 100  ish2=0                    ! set to 1 if you want screen-output 
                                ! of energy-monentum Tensor
      do iy=1,nyico
        yy=yminico+(float(iy)-0.5)*(ymaxico-yminico)/nyico
        do ix=1,nxico
          xx=xminico+(float(ix)-0.5)*(xmaxico-xminico)/nxico
          do iz=1,nzico
            zz=zminico +(float(iz)-0.5)*(zmaxico-zminico )/nzico
c           the flow is the one of energy-momentum 
            do i=1,4
              un(i,ix,iy,iz)=IcoT(i,4,ix,iy,iz)
            enddo
            unorm=sqrt(max(0.,un(4,ix,iy,iz)**2-un(3,ix,iy,iz)**2
     $           -un(2,ix,iy,iz)**2-un(1,ix,iy,iz)**2))
            if(unorm.gt.0.)then
              do i=1,4
                uu(i)=un(i,ix,iy,iz)/unorm
              enddo
            else
              do i=1,4
                uu(i)=0. 
              enddo
            endif
c
c           if IcoE(...)  we will have the energy-density
c           if IcoV(1..3,...) the flow-velocity

            IcoE(ix,iy,iz)=0.
            do i=1,3
              IcoV(i,ix,iy,iz)=0.
            enddo
            do ifl=1,3
              IcoF(ifl,ix,iy,iz)=0.
c$$$              unorm2(ifl)=sqrt(max(0.,IcoC(ifl,4,ix,iy,iz)**2
c$$$     $             -IcoC(ifl,3,ix,iy,iz)**2
c$$$     $             -IcoC(ifl,2,ix,iy,iz)**2
c$$$     $             -IcoC(ifl,1,ix,iy,iz)**2))
              if(unorm.ne.0.) then
                do i1=1,4
                  f1=1.0
                  if(i1.le.3) f1=-1.0 !  consider metric g_mu_nu
                  IcoF(ifl,ix,iy,iz)=IcoF(ifl,ix,iy,iz)
     $                 +f1*IcoC(ifl,i1,ix,iy,iz)*un(i1,ix,iy,iz)
     $                 /unorm
                enddo
              endif
            enddo
c...........
            if(uu(4).gt.0.)then
              if(ish2.ge.1)
     $             write (*,'(T1,"  energy-momentum Tensor at x=",f4.1
     $             ," y=",f4.1," eta=",f4.1
     $             ,T60,"current ",g12.6)') xx,yy,zz!,unorm2(1)
              do i1=1,4
                do i2=1,4
                  f1=1.0
                  if(i1.le.3) f1=-1.0 !  consider metric g_mu_nu 
                  f2=1.0
                  if(i2.le.3) f2=-1.0 !  consider metric g_mu_nu 
                                !     for tau != 1 one has to multiply tau**2
                                !     in the third row because of 
                                !     hyperbolic coordinates
                  IcoE(ix,iy,iz)=IcoE(ix,iy,iz)
     $                 +f1*f2*IcoT(i1,i2,ix,iy,iz)*uu(i1)*uu(i2)
                  if(ish2.ge.1)
     $                 write (*,'(1pg13.6," ",$)') IcoT(i1,i2,ix,iy,iz) 
                enddo
c$$$               if(ish2.ge.1) write (*,'(" |  ",1pg13.6)')
c$$$     $               IcoC(1,i1,ix,iy,iz)/max(0.00001,unorm2(1))
              enddo
              if(ish2.ge.1)write (*,*) 
              do i=1,3
                IcoV(i,ix,iy,iz)=uu(i)/uu(4)
              enddo
            endif
          enddo
        enddo
      enddo
      return
      end




c---------------------------------------------------------------------- 
      subroutine hyperbl(tau)
c----------------------------------------------------------------------
c   1.  t0 ==> t0+tsh  so that all particles cross the hyperbola
c   2.  plot new formation points : xrange zmin zmax
c       plot hyperbola  t**2-z**2=tau**2
c       plot intersections
c   3.  change into hyperbolic coordinates
c       boost momenta into new frame 
c   4.  for given observe point (xobs(3)), construct energy momentum 
c       tensor (tens(4,4)), calculate flow velocity and energy density flvlct(4)
c---------------------------------------------------------------------- 
      
      include 'nexus.inc' 
      include 'nexus.incico'

      dimension xnew(4),xold(4),p(4),pnew(4),pold(4)      

      call utpri('hyperbl',ish,ishini,4)

	
c  t0 ==> t0+tsh  so that all particles cross the hyperla
      if(ish.ge.2)call alist('list of formation points&',1,nptl)
 
      tsh=0.
      ddd=0.001
      do i=1,nptl
c        if(mod(istptl(i),10).eq.0.and.abs(idptl(i)).le.10)then      
	if(mod(istptl(i),10).eq.0)then             
          pz=pptl(3,i)
          e=pptl(4,i)
          z0=xorptl(3,i)
          t0=xorptl(4,i)
	  
          if(abs(pz).eq.e.and.t0.le.sign(1.,pz)*z0)then
            ttt=sign(1.,pz)*z0-t0+ddd
            if(tsh.le.ttt)tsh=ttt	    	    
          endif
	  
        endif
      enddo
      print*,'t0 shift',tsh
        
      if(tsh.ne.0)then        
        if(ish.ge.1)write(ifch,*)'t0 shift',tsh
        do i=1,nptl
          xorptl(4,i)=xorptl(4,i)+tsh
        enddo
	if(ish.ge.2)call alist('list of new formation points&',1,nptl)
      endif
      
      write(ifhi,*)'newpage'             
      write(ifhi,*)'zone 2 3 1' 
      zmin=-20.
      zmax= 20.
      call ztplot(1,zmin,zmax,tau)

c calculate intersections
      do i=1,nptl
        if(mod(istptl(i),10).eq.0)then       
          do j=1,4
            xold(j)=xorptl(j,i)
            p(j)=pptl(j,i)
          enddo
          call finsec(xnew,tau,p,xold)
          do j=1,4
            xorptl(j,i)=xnew(j)            
          enddo  
        endif
      enddo
      if(ish.ge.2)call alist('list in hyperbola&',1,nptl)

      call ztplot(2,zmin,zmax,tau)

c  eta-rap plot before boost
      write(ifhi,*)'zone 2 3 1'        
      call erplot(tau,1)

c    calculate hyperbolic coodinates and boost the momenta into frame F_eta
      do i=1,nptl
        if(mod(istptl(i),10).eq.0)then       
          do j=1,4
            xold(j)=xorptl(j,i)
            pold(j)=pptl(j,i)
          enddo
          call boostem(tau,pold,xold,pnew,xnew)
          do j=1,4
            xorptl(j,i)=xnew(j)
            pptl(j,i)=pnew(j)
          enddo            
        endif
      enddo  
      if(ish.ge.2)call alist('list in new frame&',1,nptl) 
     
c  eta-rap plot after boost        
      call erplot(tau,2)

c  x-y plot 
        zmin=-10.
        zmax= 10.
      call xyplot(1,zmin,zmax)
      call xyplot(2,zmin,zmax)  ! eta=0.
      
c  x-eta plot 
        zmin=-10.
        zmax= 10.
      call xeplot(1,zmin,zmax)
      call xeplot(2,zmin,zmax)  ! y=0     
  
c  for given observe point (xobs(3)), construct energy momentum 
c  tensor (tens(4,4)) and calculate flow velocity and energy density flvlct(4)
c  by calling tensor16(tau,xobs,tens,flvlct)      
     
c flow velocity and energy density in the x-y plane at eta=0.   
      print*,'xminico,xmaxico,nxico,yminico,ymaxico,nyico'
      print*,xminico,xmaxico,nxico,yminico,ymaxico,nyico
      call efxyplot(tau,xminico,xmaxico,nxico,yminico,ymaxico,nyico)
      
c flow velocity and energy density in the x-eta plane at y=0. 
      print*,'xminico,xmaxico,nxico,zminico,zmaxico,nzico'
      print*,xminico,xmaxico,nxico,zminico,zmaxico,nzico
      call efxzplot(tau,xminico,xmaxico,nxico,zminico,zmaxico,nzico)
            
      call utprix('hyperbl',ish,ishini,4)     
      end


c---------------------------------------------------------------------- 
	subroutine finsec(xnew,tau,p,xold)
c---------------------------------------------------------------------- 
c	input tau (hyperbola),  p(4),xold(4)
c       output intersection xnew(4)
c    
c       solve  z=z0+pz/e *(t-t0) and  t**2-z**2=tau**2
c---------------------------------------------------------------------- 

	dimension xnew(4),xold(4),p(4)

	px=p(1)
        py=p(2)
        pz=p(3)
        e=p(4)
       
        x0=xold(1)
        y0=xold(2)
        z0=xold(3)
        t0=xold(4)

        aa=pz/e
        bb=z0-pz*t0/e

        if(abs(aa).eq.1)then    ! only possible for mt=0 particle.
          t=-(bb**2+tau**2)/2./aa/bb
          x=x0
          y=y0
          z=z0+aa*(t-t0)                        
        else
          a=1.-aa**2
          b=-2.*aa*bb
          c=-(bb**2+tau**2)
          delta=b**2-4.*a*c

          t=(-b+sqrt(delta))/2./a
          x=x0+(t-t0)*px/e
          y=y0+(t-t0)*py/e
          z=z0+(t-t0)*pz/e           
        endif           

         xnew(1)=x
         xnew(2)=y
         xnew(3)=z
         xnew(4)=t
        end

c---------------------------------------------------------------------- 
	subroutine boostem(tau,pold,xold,pnew,xnew)
c---------------------------------------------------------------------- 
c	input   xold(4) and pold(4)
c       output  xnew(4): hyperbolic coodinates
c               pnew(4): momentum in new frame (tau,eta)
c---------------------------------------------------------------------- 

	dimension pnew(4),pold(4),xold(4),xnew(4)

        xnew(1)=xold(1)
        xnew(2)=xold(2) 
        if(xold(3).gt.0.)then      
          xnew(3)=alog((xold(4)+xold(3))/tau)
        else
          xnew(3)=alog(tau/(xold(4)-xold(3)))
        endif
        xnew(4)=tau
        eta=xnew(3)

	pnew(1)=pold(1)
        pnew(2)=pold(2)
	if(abs(pold(3)).ne.pold(4))then
	  amt=sqrt(pold(4)**2-pold(3)**2)
          rap=.5*alog((pold(4)+pold(3))/(pold(4)-pold(3)))
          pnew(3)=amt*sinh(rap-eta)
          pnew(4)=amt*cosh(rap-eta)
        else
	  pnew(3)=pold(3)*cosh(eta)+pold(4)*sinh(eta)
          pnew(4)=pold(4)*cosh(eta)+pold(3)*sinh(eta)
        endif

        end
	
c---------------------------------------------------------------------
	subroutine ztplot1(im,zmin,zmax,tau)
c---------------------------------------------------------------------

	include 'nexus.inc'

        ymax=sqrt(zmax**2+tau**2)+1
        ymin=-ymax/10.
        write(ifhi,*)'openhisto name hybl xrange',zmin,zmax
        write(ifhi,*)'yrange ',ymin,ymax,'  htyp lin'
	write(ifhi,*)'text 0 0 "xaxis z (fm)" '
        write(ifhi,*)'text 0 0 "yaxis t (fm)" '
	write(ifhi,*)'text 0.4 0.9 "[t]=1fm" '
	
	if(im.eq.1)then
	  write(ifhi,*)'text 0.5 0.8 " formation points" '
	else ! im=2
	  write(ifhi,*)'text 0.5 0.8 " in hyperbola" '
	endif    
        write(ifhi,*)'array 2'
        do i=1,50
          z=zmin+(i-0.5)*(zmax-zmin)/50.
          t=sqrt(z**2+tau**2)
          write(ifhi,*)z,t        
        enddo
        write(ifhi,*)'endarray closehisto plot 0-'      
        end

c---------------------------------------------------------------------
	subroutine ztplot(im,zmin,zmax,tau)
c---------------------------------------------------------------------
        include 'nexus.inc'

        ymax=sqrt(zmax**2+tau**2)+1
        ymin=-ymax/10.
	

	call ztplot1(im,zmin,zmax,tau)
	print*,'call ztplot1 end'

        write(ifhi,*)'openhisto name hyop xrange',zmin,zmax
        write(ifhi,*)'yrange ',ymin,ymax,' htyp pnt '
        write(ifhi,*)'text 0 0 "xaxis z" '
        write(ifhi,*)'text 0 0 "yaxis t" '
	write(ifhi,*)'text 0.1 0.8 "partons+diquarks" '
        write(ifhi,*)'array 2'
        do i=1,nptl                
          if((mod(istptl(i),10).eq.0.and.abs(idptl(i)).le.10).or.
     &	     (mod(istptl(i),10).eq.0.and.mod(idptl(i),100).eq.0))
     &      write(ifhi,*)xorptl(3,i),xorptl(4,i) 
        enddo
        write(ifhi,*)'endarray closehisto plot 0'
	
	call ztplot1(im,zmin,zmax,tau)
    
        write(ifhi,*)'openhisto name hyop xrange',zmin,zmax
        write(ifhi,*)'yrange ',ymin,ymax,' htyp pnt '
        write(ifhi,*)'text 0 0 "xaxis z" '
        write(ifhi,*)'text 0 0 "yaxis t" '
	write(ifhi,*)'text 0.1 0.8 "spectators" '
        write(ifhi,*)'array 2'
        do i=1,nptl   
          if(istptl(i).eq.0.and.i.le.maproj+matarg)
     &      write(ifhi,*)xorptl(3,i),xorptl(4,i)                      
        enddo
        write(ifhi,*)'endarray closehisto plot 0'
     	
	call ztplot1(im,zmin,zmax,tau)

        write(ifhi,*)'openhisto name hyop xrange',zmin,zmax
        write(ifhi,*)'yrange ',ymin,ymax,' htyp pnt '
        write(ifhi,*)'text 0 0 "xaxis z" '
        write(ifhi,*)'text 0 0 "yaxis t" '
	write(ifhi,*)'text 0.1 0.8 "hadrons (remnants)" '
        write(ifhi,*)'array 2'
        do i=1,nptl   
          if((ityptl(i).eq.40.or.ityptl(i).eq.10).and.istptl(i).le.1)
     $    write(ifhi,*)xorptl(3,i),xorptl(4,i)
        enddo
        write(ifhi,*)'endarray closehisto plot 0'   

        end

c---------------------------------------------------------------------
	subroutine xyplot(im,zmin,zmax)
c---------------------------------------------------------------------
        include 'nexus.inc'
  
        sigma=0.5
        zthick=sqrt(10.)*sigma
	zposit=0.
        write(ifhi,*)'openhisto name hyop xrange',zmin,zmax
        write(ifhi,*)'yrange ',zmin,zmax,' htyp pnt '
        write(ifhi,*)'text 0 0 "xaxis x (fm)" '
        write(ifhi,*)'text 0 0 "yaxis y (fm)" '
	if(im.eq.1)then 
	  write(ifhi,*)'text 0.5 0.9 "all [c]" '
	else
	  write(ifhi,*)'text 0.5 0.9 "[c] (-1.6,1.6) " ' 
        endif
        write(ifhi,*)'array 2'
        do i=1,nptl          
         if(im.eq.1)then      
          if(mod(istptl(i),10).eq.0)
     &      write(ifhi,*)xorptl(1,i),xorptl(2,i)
         else
           if(abs(xorptl(3,i)-zposit).le.zthick.
     &      and.mod(istptl(i),10).eq.0)
     &      write(ifhi,*)xorptl(1,i),xorptl(2,i)
          endif
        enddo
        write(ifhi,*)'endarray closehisto plot 0'   

        end

c---------------------------------------------------------------------
	subroutine xeplot(im,zmin,zmax)
c---------------------------------------------------------------------
        include 'nexus.inc'
       
	sigma=0.5
        zthick=sqrt(10.)*sigma
	zposit=0.
        write(ifhi,*)'openhisto name hyop xrange',zmin,zmax
        write(ifhi,*)'yrange ',zmin,zmax,' htyp pnt '
        write(ifhi,*)'text 0 0 "xaxis x (fm)" '
        write(ifhi,*)'text 0 0 "yaxis [c]" '
	if(im.eq.1)then 
	  write(ifhi,*)'text 0.5 0.9 "all y" '
	else
	  write(ifhi,*)'text 0.5 0.9 "y (-1.6,1.6) " ' 
        endif
        write(ifhi,*)'array 2'
        do i=1,nptl          
         if(im.eq.1)then      
          if(mod(istptl(i),10).eq.0)
     &      write(ifhi,*)xorptl(1,i),xorptl(3,i)
         else
           if(abs(xorptl(2,i)-zposit).le.zthick.
     &	     and.mod(istptl(i),10).eq.0)
     &      write(ifhi,*)xorptl(1,i),xorptl(3,i)
          endif
        enddo
        write(ifhi,*)'endarray closehisto plot 0'   

        end

c---------------------------------------------------------------------
	subroutine erplot(tau,im)  ! eta-rapidity plot
c       im=1, before boost;else, after boost.	
c---------------------------------------------------------------------
        include 'nexus.inc'

         write(ifhi,*)'! partons'
         write(ifhi,*)'openhisto name etarap1'
         write(ifhi,*)' xrange -15 15 yrange -10 10'
         write(ifhi,*)'htyp pnt'
         write(ifhi,*)'text  0 0 "xaxis [c]" '
         write(ifhi,*)'text  0 0 "yaxis rapidity" '
	 if(im.eq.1)then 
	   write(ifhi,*)'text 0.1 0.1 "partons before boost" '
	 else
	   write(ifhi,*)'text 0.1 0.1 "partons after boost" ' 
         endif
         write(ifhi,*)'array 2'
         do i=1,nptl                            
          if((mod(istptl(i),10).eq.0.and.abs(idptl(i)).le.10).or.
     $  (mod(istptl(i),10).eq.0.and.mod(idptl(i),100).eq.0))then
            eta=xorptl(3,i)           
            if(im.eq.1)then
              if(xorptl(3,i).gt.0)then
                eta=alog((xorptl(4,i)+xorptl(3,i))/tau)
              else
                eta=alog(tau/(xorptl(4,i)-xorptl(3,i))) 
              endif 
            endif                       
            if(abs(pptl(3,i)).ne.pptl(4,i))then
	      rap=.5*alog((pptl(4,i)+pptl(3,i))/(pptl(4,i)-pptl(3,i)))
              write(ifhi,*)eta,rap   
	    endif  
          endif
         enddo
         write(ifhi,*)'endarray closehisto plot 0'

         write(ifhi,*)'! spectators'
         write(ifhi,*)'openhisto name etarap1'
         write(ifhi,*)' xrange -15 15 yrange -10 10'
         write(ifhi,*)'htyp pnt'
         write(ifhi,*)'text  0 0 "xaxis [c]" '
         write(ifhi,*)'text  0 0 "yaxis y" '
	 if(im.eq.1)then 
	   write(ifhi,*)'text 0.1 0.1 "spectators before boost" '
	 else
	   write(ifhi,*)'text 0.1 0.1 "spectators after boost" ' 
         endif
         write(ifhi,*)'array 2'
         do i=1,nptl                         
          if(istptl(i).eq.0.and.i.le.maproj+matarg)then              
              eta=xorptl(3,i)           
              if(im.eq.1)then
               if(xorptl(3,i).gt.0)then
                eta=alog((xorptl(4,i)+xorptl(3,i))/tau)
               else
                eta=alog(tau/(xorptl(4,i)-xorptl(3,i))) 
               endif 
              endif            
	      if(abs(pptl(3,i)).ne.pptl(4,i))then
	      rap=.5*alog((pptl(4,i)+pptl(3,i))/(pptl(4,i)-pptl(3,i)))
              write(ifhi,*)eta,rap   
	      endif                 
           endif
         enddo
         write(ifhi,*)'endarray closehisto plot 0'

         write(ifhi,*)'! other hadrons'
         write(ifhi,*)'openhisto name etarap1'
         write(ifhi,*)' xrange -15 15 yrange -10 10'
         write(ifhi,*)'htyp pnt'
         write(ifhi,*)'text  0 0 "xaxis [c]" '
         write(ifhi,*)'text  0 0 "yaxis y" '
	 if(im.eq.1)then 
	   write(ifhi,*)'text 0.1 0.1 "hadrons before boost" '
	 else
	   write(ifhi,*)'text 0.1 0.1 "hadrons after boost" ' 
         endif
         write(ifhi,*)'array 2'
         do i=1,nptl                            
          if((ityptl(i).eq.40.or.ityptl(i).eq.10).and.istptl(i).le.1
     $     .and.iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41)then
              eta=xorptl(3,i)           
              if(im.eq.1)then
               if(xorptl(3,i).gt.0)then
                eta=alog((xorptl(4,i)+xorptl(3,i))/tau)
               else
                eta=alog(tau/(xorptl(4,i)-xorptl(3,i))) 
               endif 
              endif           
              if(abs(pptl(3,i)).ne.pptl(4,i))then
	      rap=.5*alog((pptl(4,i)+pptl(3,i))/(pptl(4,i)-pptl(3,i)))
              write(ifhi,*)eta,rap   
	      endif                            
           endif
         enddo
         write(ifhi,*)'endarray closehisto plot 0'

       end

c-------------------------------------------------------------------
	subroutine tensor16(tau,xobs,tens,flvlct)
c-------------------------------------------------------------------
c    for given position xobs(3)
c    construct momentum tensor tens(4,4) 
c    calculate the local comoving frame ucf(4) 
c    and the flow velocity flvlct(4) ! the 4th component is energy density
c-------------------------------------------------------------------
	include 'nexus.inc'
	include 'nexus.incico'
        double precision xobs(3),tens(4,4),ucf(4),flvlct(4)  ! mu=1,4 : x y z t
	double precision x,y,z,px,py,pz,x0,y0,z0,e,www,unorm!,dis2
	x=xobs(1)
        y=xobs(2)
        z=xobs(3)

	do m=1,4
        do n=m,4
          tens(m,n)=0.d0
        enddo
        enddo     
 	sigma=.5  	  ! Gaussian dis. sigma
       
        istrs=icostrg   
        iremn=icoremn   
        ispec=icospec    
	  
        ii=0       
        do i=1,nptl
	  iok=0
	  
	if(ispec.ge.1.and.istptl(i).eq.0.and.i.le.maproj+matarg)iok=1
        if(iremn.ge.1.and.(ityptl(i).eq.40.or.ityptl(i).eq.10)
     $       .and.istptl(i).le.1)then
          if(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41)iok=1
        endif	
        if(istrs.ge.1)then
	  if((mod(istptl(i),10).eq.0.and.abs(idptl(i)).le.10).or.
     $  (mod(istptl(i),10).eq.0.and.mod(idptl(i),100).eq.0))iok=1
        endif   

          if(iok.eq.1)then
	  ii=ii+1

          px=pptl(1,i)
          py=pptl(2,i)
          pz=pptl(3,i)
          e=pptl(4,i)
          x0=xorptl(1,i)
          y0=xorptl(2,i)
          z0=xorptl(3,i)
	
          d2=(x-x0)**2+(y-y0)**2+tau**2*(z-z0)**2
	  if(d2.gt.10.*sigma**2)then
             www=0.
          else
             www=exp(-d2/2./sigma**2)
          endif
	  
c          print*,'dis2,www',dis2,www

          tens(1,1)=tens(1,1)+px**2/e*www
          tens(1,2)=tens(1,2)+px*py/e*www
          tens(1,3)=tens(1,3)+px*pz/e*www
          tens(1,4)=tens(1,4)+px*www
          tens(2,2)=tens(2,2)+py**2/e*www
          tens(2,3)=tens(2,3)+py*pz/e*www
          tens(2,4)=tens(2,4)+py*www
          tens(3,3)=tens(3,3)+pz**2/e*www
          tens(3,4)=tens(3,4)+pz*www
          tens(4,4)=tens(4,4)+e*www

c         if(www.ne.0)print*,'px,www,tens(1,4)',px,www,tens(1,4)
	 
          endif	 
        enddo
                 
        do m=2,4
        do n=1,m-1
          tens(m,n)=tens(n,m)
        enddo
        enddo        

	rnorm=(2.*pi)**(1.5)*sigma**3 
	do m=1,4
        do n=m,4
          tens(m,n)=tens(m,n)/rnorm  ! 3-d Gaussian dis. normalization
        enddo
        enddo     

        unorm=0.
	do m=1,4          
          unorm=unorm+tens(m,4)**2
        enddo
        unorm=sqrt(unorm)
c        print*,'unorm ',unorm     

	do m=1,4  
          if(unorm.ne.0)then        
            ucf(m)=tens(m,4)/unorm
          else
            ucf(m)=0.d0
          endif     
        enddo

        do m=1,3
         if(ucf(4).ne.0)then 
           flvlct(m)= ucf(m)/ucf(4)
          else
           flvlct(m)=0.d0
          endif
        enddo 
	
c plot rapidity  y=0.5 alog ((1+v_z)/(1-v_z)) instead of z-flow;
        vz=flvlct(3)
        flvlct(3)=0.5*alog((1+vz)/(1-vz))
          
	flvlct(4)=0.d0
        do m=1,4
        do n=1,4          
          flvlct(4)=flvlct(4)+tens(m,n)*ucf(m)*ucf(n)
        enddo
        enddo  
	
c      	print*,'tens(1,4),unorm,ucf(1),flvlct(1),flvlct(4)',
c     $	tens(1,4),unorm,ucf(1),flvlct(1),flvlct(4)

	end
        
c--------------------------------------------------------------
	subroutine efxyplot(tau,xmin,xmax,nxbin,ymin,ymax,nybin)
c--------------------------------------------------------------
c   energy density and flow velocity plot in the x-y plane at eta=0
c--------------------------------------------------------------
	include 'nexus.inc'
    	double precision xobs(3),tens(4,4),flvlct(4)  ! mu=1,4 : x y z t
                    
        do m=1,nxbin
        do n=1,nybin
         xobs(1)=xmin+(m-0.5)*(xmax-xmin)/float(nxbin) ! q1
	 xobs(2)=ymin+(n-0.5)*(ymax-ymin)/float(nybin) ! q2         
         xobs(3)=0.  ! q3=eta=0.        
       
	 call tensor16(tau,xobs,tens,flvlct)
         write(1,*)xobs(1),xobs(2),(flvlct(mm),mm=1,4)

        enddo
        enddo

        end
        

c--------------------------------------------------------------
	subroutine efxzplot(tau,xmin,xmax,nxbin,ymin,ymax,nybin)
c--------------------------------------------------------------
c   energy density and flow velocity plot in the x-z plane at y=0
c--------------------------------------------------------------
	include 'nexus.inc'
    	double precision xobs(3),tens(4,4),flvlct(4)  ! mu=1,4 : x y z t
                    
        do m=1,nxbin
        do n=1,nybin
         xobs(1)=xmin+(m-0.5)*(xmax-xmin)/float(nxbin)    ! q1
	 xobs(2)=0.                                      ! q2         
         xobs(3)=ymin+(n-0.5)*(ymax-ymin)/float(nybin)    ! q3=eta        
       
	 call tensor16(tau,xobs,tens,flvlct)
         write(2,*)xobs(1),xobs(3),(flvlct(mm),mm=1,4)	
        enddo
        enddo

        end
        

