c-----------------------------------------------------------------------
      subroutine xtauev(iii)  
c-----------------------------------------------------------------------
c  analyses space time evolution.
c  iii=0: initialisation (array filled with zeros)
c  iii=1: analysis
c  iii=2: printing the results into histo file        
c-----------------------------------------------------------------------
      include 'nexus.inc'
      parameter (maxtyp=10,maxtau=150)
      common/tau/nnnptl(maxtyp,maxtau)
      double precision tpro,zpro,ttar,ztar,ttaus,detap,detat
      common/cttaus/tpro,zpro,ttar,ztar,ttaus,detap,detat 
      integer jc(nflav,2)
      
      if(ixtau.ne.1)stop'ixtau must be 1'
      
      taumi=-2
      delt=0.1

      if(iii.eq.0)then

c        ifirst=0
        do m=1,maxtyp
        do nt=1,maxtau
        nnnptl(m,nt)=0
        enddo
        enddo

      elseif(iii.eq.1)then

        ttaus=taumi-delt
        do 2 nt=1,maxtau
          ttaus=ttaus+delt       
          do 3 i=maproj+matarg+1,nptl
          is=istptl(i)
          id=idptl(i)
          ida=iabs(idptl(i))
          call jtain(i,x,y,z,t,n,1)
          if(n.eq.1.or.n.eq.2.or.n.eq.9)goto 3           
        
            if(dezptl(i).ne.0..and.iyptl(i).ne.0)then
              call jintep(i,x,y,z,t,sz,eps,rho)
              if(eps.lt.aouni)goto 3 !min-dichte
              nnnptl(1,nt)=nnnptl(1,nt)+1         !---number of droplets  
              nnnptl(2,nt)=nnnptl(2,nt)+pptl(5,i) !---sum of droplet masses
            elseif(0.le.is.and.is.le.11)then
            call idquac(i,nq,ns,na,jc)
              if(ida/10.eq.12.or.id/10.eq.11)then
                nnnptl(3,nt)=nnnptl(3,nt)+1         !---sum of pi's and rho's
              elseif(nq.le.-3)then
                nnnptl(4,nt)=nnnptl(4,nt)-nq/3         !---sum of baryon number
              endif
            endif
            
    3     continue
    2   continue
     
      elseif(iii.eq.2)then 
      
        write(ifhi,'(a)')       'array 2'
        do nt=1,maxtau
        tau=taumi+(nt-0.5)*delt
        rat=nnnptl(nint(xpar1),nt)/float(nevent)
        write(ifhi,'(2e12.4)')tau,rat
        enddo
        write(ifhi,'(a)')       '  endarray'
      
      endif

      end    

c-----------------------------------------------------------------------
      subroutine wclu
c-----------------------------------------------------------------------
c     analysis. droplet (resonance) formation and decay.
c     fills arclu(n,k); k:mass bin.
c     n=1,12: droplet formation (m=meson, b=baryon, ab=antibaryon
c       s=strange, as=antistrange, ns=nonstrange).
c       arclu contains the number of droplets for the foll. reactions:
c          n=1:   m+m
c          n=2:   m+b
c          n=3:   b+b
c          n=4:   m+ab
c          n=5:   b+ab
c          n=6:   p+p
c          n=7:   p+lda
c          n=8:   m/s+b/ns
c          n=9:   m/ns+b/s
c          n=10:  m/ns+ab/as
c          n=11:  m/as+ab/ns
c          n=12:  m/ns+ab/ns
c     n=13,60: droplet decay.
c          n=13,16:  # of all, k+, k-, lda   from m
c          n=17,20:  # of all, k+, k-, lda   from b
c          n=21,24:  # of all, k+, k-, lda   from bb (6 quarks)
c          n=25,36:  like 13-24, however nonstrange droplets required
c          n=37,60:  # of droplets corr to n=13,36 (for norm.)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      integer ifuptl(mxptl)
      parameter(nclu=60,kclu=25)
      common/cclu/arclu(nclu,kclu),aclu(kclu)
      real tar(nclu)
      parameter (ncomx=100)
      integer iar(ncomx)
      integer jcdu(nflav,2)
      amin=0
      amax=5
 
      if(nrevt.eq.1)then
      do 44 k=1,kclu
      aclu(k)=amin+(k-.5)*(amax-amin)/kclu
      do 44 n=1,nclu
44    arclu(n,k)=0
      endif
 
      do 1 i=1,nptl
      ifuptl(i)=0
      if(istptl(i).ne.1.or.iorptl(i).eq.-1)goto1
         if(ifrptl(1,i).ne.0.and.istptl(ifrptl(1,i)).ne.2)then
      if(ifrptl(2,i).lt.ifrptl(1,i))
     *call utstop('wclu: ifrptl2<ifrptl1&')
      en=pptl(4,i)
      do 2 j=ifrptl(1,i),ifrptl(2,i)
2     en=en-pptl(4,j)
      if(abs(en/pptl(4,i)).gt.1e-3)then
      if(ish.ge.1)then
      call utmsg('jclu  ')
      write(ifch,*)'*****  en_droplet.ne.en_fragments.'
      write(ifch,*)'en_cl, en_cl-en_fr:',pptl(4,i),en
      call utmsgf
      endif
      endif
         else
      ifuptl(i)=2
         endif
1     continue
 
      if(ish.eq.10)then
      stop'change this????????'
c      write(ifch,101)('-',i=1,16)
c101   format(1x,'ptl list in wclu'/1x,16a1)
c      do 10 i=1,nptl
c10    write(ifch,100)i,idptl(i),ifuptl(i)
c     *,iorptl(i),jorptl(i),ifrptl(1,i),ifrptl(2,i),istptl(i)
c100   format(1x,i4,i10,i6,7x,2i4,7x,2i4,i8)
      endif
 
      do 3 i=1,nptl
      if(istptl(i).eq.2)goto3
      io=iorptl(i)
      jo=jorptl(i)
      if(jo.eq.0)goto3
      ifuptl(io)=ifuptl(io)-2
      ifuptl(jo)=ifuptl(jo)-2
      if(abs(pptl(4,i)-pptl(4,io)-pptl(4,jo)).gt.1e-3)then
      ifuptl(io)=ifuptl(io)+1
      ifuptl(jo)=ifuptl(jo)+1
      goto3
      endif
      idi=idptl(io)
      idj=idptl(jo)
      call idquac(io,nqi,nsi,ndummy,jcdu)
      call idquac(jo,nqj,nsj,ndummy,jcdu)
      k=1+(pptl(5,i)-amin)/(amax-amin)*kclu
         if(k.ge.1.and.k.le.kclu)then
      if(nqi.eq.0.and.nqj.eq.0)       arclu( 1,k)=arclu( 1,k)+1
      if(nqi.eq.0.and.nqj.eq.3
     *.or.nqj.eq.0.and.nqi.eq.3)      arclu( 2,k)=arclu( 2,k)+1
      if(nqi.eq.3.and.nqj.eq.3)       arclu( 3,k)=arclu( 3,k)+1
      if(nqi.eq.0.and.nqj.eq.-3
     *.or.nqj.eq.0.and.nqi.eq.-3)     arclu( 4,k)=arclu( 4,k)+1
      if(nqi.eq.3.and.nqj.eq.-3
     *.or.nqj.eq.3.and.nqi.eq.-3)     arclu( 5,k)=arclu( 5,k)+1
      if(idi.eq.1120.and.idj.eq.1120) arclu( 6,k)=arclu( 6,k)+1
      if(idi.eq.1120.and.idj.eq.2130
     *.or.idj.eq.1120.and.idi.eq.2130)arclu( 7,k)=arclu( 7,k)+1
      if(nqi.eq.0.and.nsi.eq.1
     *.and.nqj.eq.3.and.nsj.eq.0
     *.or.nqj.eq.0.and.nsj.eq.1
     *.and.nqi.eq.3.and.nsi.eq.0)     arclu( 8,k)=arclu( 8,k)+1
      if(nqi.eq.0.and.nsi.eq.0
     *.and.nqj.eq.3.and.nsj.eq.1
     *.or.nqj.eq.0.and.nsj.eq.0
     *.and.nqi.eq.3.and.nsi.eq.1)     arclu( 9,k)=arclu( 9,k)+1
      if(nqi.eq.0.and.nsi.eq.0
     *.and.nqj.eq.-3.and.nsj.eq.-1
     *.or.nqj.eq.0.and.nsj.eq.0
     *.and.nqi.eq.-3.and.nsi.eq.-1)   arclu(10,k)=arclu(10,k)+1
      if(nqi.eq.0.and.nsi.eq.-1
     *.and.nqj.eq.-3.and.nsj.eq.0
     *.or.nqj.eq.0.and.nsj.eq.-1
     *.and.nqi.eq.-3.and.nsi.eq.0)    arclu(11,k)=arclu(11,k)+1
      if(nqi.eq.0.and.nsi.eq.0
     *.and.nqj.eq.-3.and.nsj.eq.0
     *.or.nqj.eq.0.and.nsj.eq.0
     *.and.nqi.eq.-3.and.nsi.eq.0)    arclu(12,k)=arclu(12,k)+1
         endif
3     continue
 
      do 4 i=1,nptl
      if(ifuptl(i).eq.0)goto4
      if(ish.ge.1)then
      call utmsg('jclu  ')
      write(ifch,*)'*****  ifuptl .ne. 0.'
      write(ifch,*)'i,ifuptl(i): ',i,ifuptl(i)
      call utmsgf
      endif
      if(ish.eq.10)then
      stop'change this???????????'
c      call utmsg('jclu  ')
c      write(ifch,*)'*****  ifuptl .ne. 0.'
c      write(ifch,*)'i,ifuptl(i): ',i,ifuptl(i)
      endif
4     continue
 
      do 5 i=1,nptl
      if(istptl(i).ne.1.or.iorptl(i).eq.-1)goto5
      if(.not.(ifrptl(1,i).ne.0.and.istptl(ifrptl(1,i)).ne.2))goto5
      k=1+(pptl(5,i)-amin)/(amax-amin)*kclu
      if(k.lt.1.or.k.gt.kclu)goto5
      call idquac(i,nq,ns,ndummy,jcdu)
      do 45 n=1,nclu
45    tar(n)=0
      iar(1)=i
      nco=1
      npo=0
7     npo=npo+1
      ipo=iar(npo)
         if(istptl(ipo).eq.2)goto5
         if(istptl(ipo).eq.0)then
      id=idptl(ipo)
      if(nq.eq.0)               tar(13)=tar(13)+1
      if(nq.eq.0.and.id.eq.130) tar(14)=tar(14)+1
      if(nq.eq.0.and.id.eq.-130)tar(15)=tar(15)+1
      if(nq.eq.0.and.id.eq.2130)tar(16)=tar(16)+1
      if(nq.eq.3)               tar(17)=tar(17)+1
      if(nq.eq.3.and.id.eq.130) tar(18)=tar(18)+1
      if(nq.eq.3.and.id.eq.-130)tar(19)=tar(19)+1
      if(nq.eq.3.and.id.eq.2130)tar(20)=tar(20)+1
      if(nq.eq.6)               tar(21)=tar(21)+1
      if(nq.eq.6.and.id.eq.130) tar(22)=tar(22)+1
      if(nq.eq.6.and.id.eq.-130)tar(23)=tar(23)+1
      if(nq.eq.6.and.id.eq.2130)tar(24)=tar(24)+1
      if(ns.eq.0.and.nq.eq.0)               tar(25)=tar(25)+1
      if(ns.eq.0.and.nq.eq.0.and.id.eq.130) tar(26)=tar(26)+1
      if(ns.eq.0.and.nq.eq.0.and.id.eq.-130)tar(27)=tar(27)+1
      if(ns.eq.0.and.nq.eq.0.and.id.eq.2130)tar(28)=tar(28)+1
      if(ns.eq.0.and.nq.eq.3)               tar(29)=tar(29)+1
      if(ns.eq.0.and.nq.eq.3.and.id.eq.130) tar(30)=tar(30)+1
      if(ns.eq.0.and.nq.eq.3.and.id.eq.-130)tar(31)=tar(31)+1
      if(ns.eq.0.and.nq.eq.3.and.id.eq.2130)tar(32)=tar(32)+1
      if(ns.eq.0.and.nq.eq.6)               tar(33)=tar(33)+1
      if(ns.eq.0.and.nq.eq.6.and.id.eq.130) tar(34)=tar(34)+1
      if(ns.eq.0.and.nq.eq.6.and.id.eq.-130)tar(35)=tar(35)+1
      if(ns.eq.0.and.nq.eq.6.and.id.eq.2130)tar(36)=tar(36)+1
      if(npo.lt.nco)goto7
         elseif(ifrptl(1,ipo).ne.0.and.istptl(ifrptl(1,ipo)).ne.2)then
      do 6 j=ifrptl(1,ipo),ifrptl(2,ipo)
      nco=nco+1
      if(nco.gt.ncomx)
     *call utstop('wclu: ncomx too small. increase dim.&')
6     iar(nco)=j
      goto7
         else
      goto5
         endif
      if(nq.eq.0)            tar(37)=tar(37)+1
      if(nq.eq.3)            tar(41)=tar(41)+1
      if(nq.eq.6)            tar(45)=tar(45)+1
      if(ns.eq.0.and.nq.eq.0)tar(49)=tar(49)+1
      if(ns.eq.0.and.nq.eq.3)tar(53)=tar(53)+1
      if(ns.eq.0.and.nq.eq.6)tar(57)=tar(57)+1
      do 8 n=13,36
8     arclu(n,k)=arclu(n,k)+tar(n)
      do 9 n=37,60
9     arclu(n,k)=arclu(n,k)+tar(1+(n-1)/4*4)
5     continue
 
      return
      end
 
c-----------------------------------------------------------------------
      subroutine wclufi
c-----------------------------------------------------------------------
c     analysis. droplet (resonance) formation and decay. normalization.
c     0 <= n <= 36, meaning of n see initial comment in subr wclu.
c-----------------------------------------------------------------------
      character*6 xvaria,yvaria
      common/vana1/xvaria,yvaria,normal,xminim,xmaxim,nrbins,hisfac
      common/accum/imsg,jerr,ntevt,nrevt,naevt,nrstr,nrptl
      parameter(nclu=60,kclu=25)
      common/cclu/arclu(nclu,kclu),aclu(kclu)
      parameter(mxbins=10000)
      common/vana4/ar(mxbins,5)

      do n=0,36

      nrbins=kclu
      da=aclu(2)-aclu(1)
      do 1 k=1,kclu
      ar(k,1)=aclu(k)
      if(n.ge.1.and.n.le.12.and.arclu(n,k).gt.0.)then
      ar(k,3)=arclu(n,k)/nrevt/da
      ar(k,4)=arclu(n,k)/nrevt/da  /   sqrt(arclu(n,k))
      elseif(n.ge.13.and.n.le.36.and.arclu(n,k).gt.0.)then
      ar(k,3)=arclu(n,k)/arclu(n+24,k)
      ar(k,4)=arclu(n,k)/arclu(n+24,k)  /  sqrt(arclu(n,k))
      elseif(arclu(n,k).gt.0.)then
      call utstop('wclufi: only optn 1-36 possible.&')
      endif
1     continue

      enddo

      return
      end
 
c-----------------------------------------------------------------------
      subroutine wimi
c-----------------------------------------------------------------------
c     analysis. calculates factorial moments.
c-----------------------------------------------------------------------
      include 'nexus.inc'
      integer nhis(32)
      double precision afacmo
      common /cfacmo/afacmo(5,32)
      common/cwimiy/ymin,ymax
      integer ifacmo(5)
      ymin=-ymximi
      ymax=ymximi
 
      if(nrevt.eq.1)then
      do 44 m=1,5
      do 44 kmax=1,32
44    afacmo(m,kmax)=0
      endif
 
      do 45 kmax=1,32
      do 40 m=1,5
40    ifacmo(m)=0
      do 47 k=1,32
47    nhis(k)=0
      do 46 i=1,nptl
      if(istptl(i).ne.0)goto46
      amtptl=sqrt(pptl(5,i)**2+pptl(1,i)**2+pptl(2,i)**2)
      ylbptl=sign(1.,pptl(3,i))*alog((pptl(4,i)+abs(pptl(3,i)))/amtptl)
      k=1+(ylbptl-ymin)/(ymax-ymin)*kmax
      if(k.ge.1.and.k.le.kmax)nhis(k)=nhis(k)+1
46    continue
      do 41 k=1,kmax
      n=nhis(k)
      ifacmo(1)=ifacmo(1)+n
      ifacmo(2)=ifacmo(2)+n*(n-1)
      ifacmo(3)=ifacmo(3)+n*(n-1)*(n-2)
      ifacmo(4)=ifacmo(4)+n*(n-1)*(n-2)*(n-3)
      ifacmo(5)=ifacmo(5)+n*(n-1)*(n-2)*(n-3)*(n-4)
41    continue
      do 42 m=1,5
42    afacmo(m,kmax)=afacmo(m,kmax)+1d0*ifacmo(m)/kmax
45    continue
 
      return
      end
 
c-----------------------------------------------------------------------
      subroutine wimino
c-----------------------------------------------------------------------
c     analysis. normalizes factorial moments.
c-----------------------------------------------------------------------
      character*6 xvaria,yvaria
      common/vana1/xvaria,yvaria,normal,xminim,xmaxim,nrbins,hisfac
      common/accum/imsg,jerr,ntevt,nrevt,naevt,nrstr,nrptl
      common/cnsta/pi,pii,hquer,prom,piom,ainfin
      double precision afacmo,f1,fm
      common /cfacmo/afacmo(5,32)
      parameter(mxbins=10000)
      common/vana4/ar(mxbins,5)
      common/cwimiy/ymin,ymax

      do mom=1,5

      nrbins=32
      do 45 kmax=1,32
      f1=afacmo(  1,kmax)/nrevt
      fm=afacmo(mom,kmax)/nrevt/f1**mom
      ar(kmax,1)=-alog((ymax-ymin)/kmax)
      if(fm.le.0d0)ar(kmax,3)=-ainfin
      if(fm.gt.0d0)ar(kmax,3)=dlog(fm)
45    continue

      enddo

      return
      end
 
c-----------------------------------------------------------------------
      subroutine xspace(mode)
c-----------------------------------------------------------------------
c     analysis. space-time evolution.
c     fills ar(i,j,k) with
c        ar: dspa:sum{1}, sspa:sum{strangn}, cspa:sum{p3/p4},
c            espa:sum{p4}, pspa:sum{p3}, tspa:sum{p3**2/p4}
c            aspa:sum{p5}, px2spa:sum{p1**2}, py2spa:sum{p2**2}
c        i: z-bin number  (for iwcent=1:baryon#-bin)
c        j: t-bin number
c        k: meson (1) or baryon (2)  (for iwcent=1: only k=1 filled)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      parameter (nspaz=51,nspat=9)
      common /cspati/dspa(nspaz,nspat,2),cspa(nspaz,nspat,2)
     *,espa(nspaz,nspat,2),pspa(nspaz,nspat,2),tspa(nspaz,nspat,2)
     *,aspa(nspaz,nspat,2),px2spa(nspaz,nspat,2),py2spa(nspaz,nspat,2)
     *,zspa(nspaz),sspa(nspaz,nspat,2),atra,dznull
      integer ibaptl(mxptl),iacptl(mxptl),ntbptl(mxptl),ntsptl(mxptl)
      real amiptl(mxptl)
      integer jcdu(nflav,2)
      parameter (mxifr=mxptl)
      integer ifr(mxifr),ifrx(mxifr)
      real vav(nspaz),rav(nspaz),pz2(nspaz)
      common/zrange/zmin,zmax
      
           if(mode.eq.1)then !-----------------------------------
      
      mami=min0(maproj,matarg)
      r0=1.19*mami**(1./3.)-1.61*mami**(-1./3.)
      atra=(r0/2)**2*pi
      tmin=wtmini
      tstep=wtstep
      zmin=-6
      zmax=6
      iz0=(nspaz-1)/2+1
 
      if(nrevt.eq.1)then
      do 44 i=1,nspaz
      zspa(i)=zmin+(i-.5)*(zmax-zmin)/nspaz
      if(i.eq.iz0+4)zplus=zspa(i)
      if(i.eq.iz0-5)zminus=zspa(i)
      if(iwcent.eq.1)zspa(i)=i-25
      do 44 j=1,nspat
      do 44 k=1,2
      dspa(i,j,k)=0.
      sspa(i,j,k)=0.
      cspa(i,j,k)=0.
      espa(i,j,k)=0.
      pspa(i,j,k)=0.
      tspa(i,j,k)=0.
      aspa(i,j,k)=0.
      px2spa(i,j,k)=0.
44    py2spa(i,j,k)=0.
      dznull=zplus-zminus
      endif
 
      do 52 i=1,nptl
      if(istptl(i).gt.1)goto52
      call idquac(i,nq,ns,ndummy,jcdu)
      ibaptl(i)=1
      if(nq.ne.0)ibaptl(i)=2
      ntbptl(i)=nq/3
      ntsptl(i)=ns
      amiptl(i)=prom+amsiac
      if(nq.eq.0)amiptl(i)=piom+amsiac
52    continue
 
      nr=0
      do 45 it=1,nspat
      t=tmin+(it-1)*tstep
      do 43 i=1,nptl
43    iacptl(i)=1
      do 46 i=1,nptl
      if(istptl(i).gt.1)goto46
      if(iacptl(i).eq.0)goto46
      if(iabs(idptl(i)).lt.100.and.iabs(idptl(i)).ne.20)goto46
      if(ispall.eq.1)then
      if(t.lt.xorptl(4,i).or.t.ge.tivptl(2,i))goto46
      else
      if(t.lt.tivptl(1,i).or.t.ge.tivptl(2,i))goto46
      if(ityptl(i).ge.10.and.ityptl(i).le.49
     *.and.pptl(5,i).gt.amiptl(i))goto46
      endif
      x=xorptl(1,i)+(t-xorptl(4,i))*pptl(1,i)/pptl(4,i)
      y=xorptl(2,i)+(t-xorptl(4,i))*pptl(2,i)/pptl(4,i)
      z=xorptl(3,i)+(t-xorptl(4,i))*pptl(3,i)/pptl(4,i)
      if(x**2+y**2.gt.atra/pi)goto46
      iz=1+(z-zmin)/(zmax-zmin)*nspaz
      if(iz.lt.1.or.iz.gt.nspaz)goto46
      ib=ibaptl(i)
      if(iwcent.eq.1)then
      if(iz.lt.iz0-4.or.iz.gt.iz0+4)goto46
      iz=25+ntbptl(i)
      if(iz.lt.1.or.iz.gt.nspaz)goto46
      ib=1
      endif
      nr=nr+1
      dspa(iz,it,ib)=dspa(iz,it,ib)+1
      sspa(iz,it,ib)=sspa(iz,it,ib)+ntsptl(i)
      cspa(iz,it,ib)=cspa(iz,it,ib)+pptl(3,i)/pptl(4,i)
      espa(iz,it,ib)=espa(iz,it,ib)+pptl(4,i)
      pspa(iz,it,ib)=pspa(iz,it,ib)+pptl(3,i)
      tspa(iz,it,ib)=tspa(iz,it,ib)+pptl(3,i)**2/pptl(4,i)
      aspa(iz,it,ib)=aspa(iz,it,ib)+pptl(5,i)
      px2spa(iz,it,ib)=px2spa(iz,it,ib)+pptl(1,i)**2
      py2spa(iz,it,ib)=py2spa(iz,it,ib)+pptl(2,i)**2
      write(ifdt,*)nr,iz,it,ib,pptl(3,i),pptl(4,i)
 
c   children: iacptl=0

      k1=0
      k2=0
      loop=0
31    loop=loop+1
      if(loop.eq.1)n=i
      if(ifrptl(1,n).gt.0)then
      if(ish.ge.3)write(ifch,*)n,' ---> ',ifrptl(1,n),ifrptl(2,n)
      do 30 k=ifrptl(1,n),ifrptl(2,n)
      if(iacptl(k).eq.0)goto30
      iacptl(k)=0
      k2=k2+1
           if(k2.gt.mxifr/10)then
      if(ish.ge.1.and.k2-1.eq.mxifr/10)then
      call utmsg('xspace')
      write(ifch,*)'*****  k2= ',k2,' > mxifr/10 = ',mxifr/10
      do 55 kk=1,k2
55    write(ifch,*)kk,'        ',ifrx(kk),'  --->  ',ifr(kk)
      call utmsgf
      endif
      if(k2.gt.mxifr)then
      call utmsg('xspace')
      write(ifch,*)'*****  k2= ',k2,' > mxifr = ',mxifr
      call utstop('xspace  : k2 > mxifr&')
      endif
           endif
      ifrx(k2)=0
      if(k.eq.ifrptl(1,n))ifrx(k2)=n
      ifr(k2)=k
30    continue
      endif
      k1=k1+1
      if(k1.le.k2)then
      n=ifr(k1)
      if(iacptl(n).ne.0)call utstop('xspace  : should not happen&')
      goto31
      endif
 
c  parents: iacptl=0

      k1=0
      k2=0
      loop=0
12    loop=loop+1
      if(loop.eq.1)n=i
      if(iorptl(n).gt.0)then
      if(ish.ge.4)write(ifch,*)n,' <--- ',iorptl(n),jorptl(n)
           if(k2+2.gt.mxifr/10)then
      if(ish.ge.1.and.(k2+1.eq.mxifr/10.or.k2.eq.mxifr/10))then
      call utmsg('xspace')
      write(ifch,*)'*****  k2+2= ',k2+2,' > mxifr/10 = ',mxifr/10
      do 56 kk=1,k2
56    write(ifch,*)kk,'        ',ifrx(kk),'  <---  ',ifr(kk)
      call utmsgf
      endif
      if(k2+2.gt.mxifr)then
      call utmsg('xspace')
      write(ifch,*)'*****  k2+2= ',k2+2,' > mxifr = ',mxifr
      call utstop('xspace  : k2+2 > mxifr&')
      endif
           endif
      if(iacptl(iorptl(n)).ne.0)then
      k2=k2+1
      ifr(k2)=iorptl(n)
      ifrx(k2)=n
      iacptl(iorptl(n))=0
      endif
      if(jorptl(n).gt.0)then
      if(iacptl(jorptl(n)).ne.0)then
      k2=k2+1
      ifr(k2)=jorptl(n)
      ifrx(k2)=0
      iacptl(jorptl(n))=0
      endif
      endif
      endif
      k1=k1+1
      if(k1.le.k2)then
      n=ifr(k1)
      if(iacptl(n).ne.0)call utstop('xspace  : should not happen (2)&')
      goto12
      endif
 
46    continue
45    continue
 
           elseif(mode.eq.2)then !-----------------------------------
           
      if(isphis.ne.1)stop'WSPAFI: isphis must be one'

      k=nint(xpar1)
       !1:mesons,2:baryons  (iwcent=1:set to 1)
      m=nint(xpar2)
       !1:vel,2:rap,3:dens,4:e-dens,5:mass/ptl,6:en*/ptl,7:pz2,8:px2,
       !9:px2/pz2,0:strangeness/ptl,99:zeta 
      j=nint(xpar3) !time
        
      t=wtmini+(j-1)*wtstep
      write(ifmt,*)'xspace:  time = ',t
      
      if(m.ne.99)then
       
      nrbins=nspaz
      if(iwcent.eq.1)k=1
      do i=1,nspaz
      pz2(i)=0
      vav(i)=0
      rav(i)=0
      if(dspa(i,j,k).ne.0.)then
      vav(i)=pspa(i,j,k)/espa(i,j,k)
      rav(i)=.5*alog((1+vav(i))/(1-vav(i)))
      endif
      enddo
 
c      rewind ifdt
c1     read(ifdt,end=2)nr,i,js,ks,ps,es
c      if(js.eq.j.and.ks.eq.k)then
c      p=-sinh(rav(i))*es+cosh(rav(i))*ps
c      pz2(i)=pz2(i)+p**2
c      endif
c      goto1
c2     continue

      do 49 i=1,nspaz
      z=zspa(i)
      ar(i,1)=z
      if(dspa(i,j,k).eq.0.)goto49
      if(i.eq.1)dz=zspa(2)-zspa(1)
      if(i.gt.1)dz=zspa(i)-zspa(i-1)
      if(iwcent.eq.1)dz=dznull
      ano=1./nrevt/atra/dz
      gma=1./sqrt(1-vav(i)**2)
      den=(dspa(i,j,k)-cspa(i,j,k)*vav(i))*gma*ano
      ede=(espa(i,j,k)-2*pspa(i,j,k)*vav(i)+tspa(i,j,k)*vav(i)**2)*
     *gma**2*ano
      ar(i,3)=0
      if(m.eq.1)ar(i,3)=vav(i)
      if(m.eq.2)ar(i,3)=rav(i)
      if(m.eq.3)ar(i,3)=den
      if(m.eq.4)ar(i,3)=ede
      if(m.eq.5)ar(i,3)=aspa(i,j,k)/dspa(i,j,k)
      if(m.eq.6)ar(i,3)=ede/den
      if(m.eq.7)stop'WSPAFI' !ar(i,3)=pz2(i)/dspa(i,j,k)
      if(m.eq.8)ar(i,3)=px2spa(i,j,k)/dspa(i,j,k)
      if(m.eq.9.and.pz2(i).ne.0.)ar(i,3)=px2spa(i,j,k)/pz2(i)
      if(m.eq.0)ar(i,3)=sspa(i,j,k)/dspa(i,j,k)
 49   continue
 
      elseif(m.eq.99)then
      
      do i=1,nrbins 
      z=zmin+(i-.5)*(zmax-zmin)/nrbins
      ar(i,1)=z
      ar(i,3)=0
      if(t.gt.0..and.abs(z).lt.t)ar(i,3)=0.5*alog((t+z)/(t-z))
      enddo
      
      endif
      
           else !-----------------------------------
           
      stop'WSPA: wrong mode'    
        
           endif !-----------------------------------
           
      return
      end

c------------------------------------------------------------------------------
      subroutine wtime(mode)
c------------------------------------------------------------------------------
c determines (mode=1) and plots (mode=2) formation time distribution
c------------------------------------------------------------------------------
      include 'nexus.inc'
      parameter (nids=3,nbns=100)
      dimension xx(nbns)
      common/cwtime/yy(nids,nbns),ww(nids,nbns)
      character cid*7,ce*4

      tmax=wtimet
      amin=wtimei
      amax=wtimea

           if(mode.eq.1)then

      ncnt=ncnt+1

      if(ncnt.eq.1)then
      do j=1,nids
      do nn=1,nbns
      yy(j,nn)=0
      enddo
      enddo
      endif

      do n=1,nptl
      if(istptl(n).ne.0)goto3

      id=idptl(n)

c determine mass am of origin of id
      i=n
    4 continue
      io=iorptl(i)
      jo=jorptl(i)
      if(io.eq.0.and.jo.eq.0)then      !string
      am=0.00001
      elseif(io.ne.0.and.jo.ne.0)then  !elastic or droplet or sec-string
      io1=iorptl(i+1)
      jo1=jorptl(i+1)
      io2=iorptl(i-1)
      jo2=jorptl(i-1)
      if(io1.eq.io.and.jo1.eq.jo .or. io2.eq.io.and.jo2.eq.jo)then
      i=io                             !elastic
      goto4
      else                             !droplet or secondary-string
      am=pptl(5,i)
      endif
      else                             !fragmentation/decay
      i=io                            
      goto4
      endif      

      if(am.lt.amin.or.am.gt.amax)goto3

      t=tivptl(1,n)
      k=1+t/tmax*nbns 
      if(k.gt.nbns)goto3
      if(k.lt.1)goto3
      if(id.eq.120.or.id.eq.-120)yy(1,k)=yy(1,k)+1
      if(id.eq.130.or.id.eq.-130)yy(2,k)=yy(2,k)+1
      if(id.eq.1120)             yy(3,k)=yy(3,k)+1

    3 continue
      enddo

           elseif(mode.eq.2)then

      do mm=1,nbns
      xx(mm)=(mm-0.5)*tmax/nbns
      do j=1,nids
      yy(j,mm)=yy(j,mm)/ncnt/(tmax/nbns)
      enddo
      enddo

      write(ifhi,'(a)')    'newpage zone 1 3 1'

      do j=1,nids
      if(j.eq.1)cid='pions  '
      if(j.eq.2)cid='kaons  '
      if(j.eq.3)cid='protons'
      write(ce,'(f4.2)')epscri
      write(ifhi,'(a)')      'openhisto'
      write(ifhi,'(a)')      'htyp lin xmod lin ymod lin'
      write(ifhi,'(a,e9.3)') 'xrange 0 ',tmax
      write(ifhi,'(a)')      'text 0 0 "xaxis formation time t"'
      write(ifhi,'(a)')      'text 0 0 "yaxis dN/dt"'
      write(ifhi,'(a)')      'text 0.1 0.91 "'//cid//'"'
      write(ifhi,'(a)')      'text 0.7 0.91 "[e]?cri!= '//ce//'"'
      write(ifhi,'(a)')      'array 2'
      do mm=1,nbns
      write(ifhi,'(2e11.3)')xx(mm),yy(j,mm)
      enddo
      write(ifhi,'(a)')    '  endarray'
      write(ifhi,'(a)')    'closehisto plot 0'
      enddo

           endif

      return
      end
